#!/usr/bin/perl -wT
=pod
//////////////////////////////////////////////////////////////////////////////
//
// Name: modify.cgi
// Date: 17/10/2010
//
// Author: Damian Lajos Brasher
// WWW: www.diaser.org.uk http://sourceforge.net/projects/diaser
// Email: dbrasher@interlinux.co.uk
// License GPL Version 3, 29 June 2007 gpl.txt
// First created 13th-15th October 2008 - Nick: 'Moonlight Sonata'.
//
//////////////////////////////////////////////////////////////////////////////
=cut

use CGI;
use strict;
my $q = new CGI;
print $q->header( "text/plain" );

# variables read in from configuration file
my $config_file;

# turn into a hash array
my $num_years_cf = 8; # example value
my $start_year_cf = 2010; # example value
my $hour1_cf = 11; # example value
my $hour2_cf = 4; # example value
my $node_a_cf = '192.168.2.2'; # example value
my $node_b_cf = '192.168.2.3'; # example value
my $node_c_cf = '192.168.2.4'; # example value
my $port_a_cf = 22; # example value
my $port_b_cf = 22; # example value
my $port_c_cf = 22; # example value
my $dry_run_cf = 0; # example value
my $low_max_bw_cf = 12800; # example value
my $tzone_a_cf = 0; # example value
my $tzone_b_cf = 5; # example value
my $tzone_c_cf = -5; # example value
my $user_acc_cf = "diasertest"; # example value
my $tout_cf = 10900; # example value
my $dir_a_cf = '/home/'; # example value
my $dir_b_cf = '/home/'; # example value
my $dir_c_cf = '/home/'; # example value
my $use_sudo_cf = 0; # example value
my $sudo_account_name_a_cf = "usera"; # example value
my $sudo_account_name_b_cf = "userb"; # example value
my $sudo_account_name_c_cf = "userc"; # example value
my $fill_start_time_cf = 11; # example value
my $volume_dir_cf = '/mnt/bacula/'; # example value
my $diff_const_prefix_cf = "DailyCriticalDiff"; # example value
my $collect_full_cf = 1; # example value
my $collect_full_day_cf = 6; # example value
my $full_prefix_cf = "CriticalFull"; # example value

print <<ENDHTML;
<form action="/cgi-bin/save_conf.cgi" method="post" target="_new">
</p>

<hr>
Set operation timing

<p class="color01_medium">

<img src="images/info.jpg" 
onmouseover="ddrivetip('Number of years of expected operation.',
'white')"; onmouseout="hideddrivetip()">

Number of years of expected operation
<select name="num_years">
ENDHTML

my $years_ops = 0; # years of operation
my $selected = ""; # use text selected if value is true
my $year = 0;
while ($years_ops <= 29) {
	$years_ops++; # decrement through the years
	$year++;        
	
	# check for selected year from configuration file
	if ( $year == $num_years_cf ) {
		$selected = "selected";
	} else { 
		$selected = ""; 
	}  
 
print <<ENDHTML;
	<option value="$year" $selected> $year
ENDHTML

}	

print <<ENDHTML;
</select>
</p>

<p class="color01_medium">

<img src="images/info.jpg" 
onmouseover="ddrivetip('First year of operation.',
'white')"; onmouseout="hideddrivetip()">

First year of operation
<select name="start_year">
ENDHTML

$years_ops = 0; # years of operation
$selected = ""; # use text selected if value is true
$year = 1990;
while ($years_ops <= 39) {
	$years_ops++; # decrement through the years
	$year++;        
	
	# check for selected year from configuration file
	if ( $year == $start_year_cf ) {
		$selected = "selected";
	} else { 
		$selected = ""; 
	}  
 
print <<ENDHTML;
	<option value="$year" $selected> $year
ENDHTML

}	

print <<ENDHTML;
</select>
</p>

<table><tr><td>

<p class="color01_medium">

<img src="images/info.jpg" 
onmouseover="ddrivetip('Times of operation over a 24 hour period, if using more than one diaser installation then use different phases or adjust LMB (see below) accordingly. The start time is assumed to be your local timezone.',
'white')"; onmouseout="hideddrivetip()">

Start time phase 1<br>
<select name="hour1">
ENDHTML
	
my $hours_ops = 0; # hours of operation
$selected = ""; # use text selected if value is true
my $hour = -1;
while ($hours_ops <= 23) {
	$hours_ops++; # decrement through the years
	$hour++;        
	
	# check for selected year from configuration file
	if ( $hour == $hour1_cf ) {
		$selected = "selected";
	} else { 
		$selected = ""; 
	}  
 
print <<ENDHTML;
	<option value="$hour" $selected> 00:$hour
ENDHTML
}

print <<ENDHTML;
</select>
</p>

</td>
<td>

<p class="color01_medium">
Start time phase 2<br>
<select name="hour2">
ENDHTML
	
$hours_ops = 0; # hours of operation
$selected = ""; # use text selected if value is true
$hour = -1;
while ($hours_ops <= 23) {
	$hours_ops++; # decrement through the years
	$hour++;        
	
	# check for selected year from configuration file
	if ( $hour == $hour2_cf ) {
		$selected = "selected";
	} else { 
		$selected = ""; 
	}  
 
print <<ENDHTML;
	<option value="$hour" $selected> 00:$hour
ENDHTML
}

print <<ENDHTML;
</select>
</p>

</td></tr></table>

<hr>
Set network details

<p class="color01_medium">

<img src="images/info.jpg" 
onmouseover="ddrivetip('Machine IP of nodes for use in your DIASER pool. The application management resides on your workstation or a node, but the working code resides on nodes only',
'white')"; onmouseout="hideddrivetip()">

<br>
Node A IP address <input type="text" name="node_a" size="15" maxlength="15" value="$node_a_cf"/><br>
Node B IP address <input type="text" name="node_b" size="15" maxlength="15" value="$node_b_cf"/><br>
Node C IP address <input type="text" name="node_c" size="15" maxlength="15" value="$node_c_cf"/><br>
</p>

<p class="color01_medium">

<img src="images/info.jpg" 
onmouseover="ddrivetip('Choose an OpenSSH port, the most used default is port 22 but this can be changed as required.',
'white')"; onmouseout="hideddrivetip()">

<br>
SSH port Node A <input type="text" name="port_a" size="2" maxlength="6" value="$port_a_cf"/><br>
SSH port Node B <input type="text" name="port_b" size="2" maxlength="6" value="$port_b_cf"/><br>
SSH port Node C <input type="text" name="port_c" size="2" maxlength="6" value="$port_c_cf"/><br>
</p>

<p class="color01_medium">

<img src="images/info.jpg" 
onmouseover="ddrivetip('Operate without transferring any data for testing and debugging.',
'white')"; onmouseout="hideddrivetip()">

Dry run? 
<select name="dry_run">
	<option value="1" > yes
	<option value="0" selected> no
</select>
</p>

<p class="color01_medium">

<img src="images/info.jpg" 
onmouseover="ddrivetip('BANDWIDTH control, please enter the Maximum speed in KBPS of your slowest network connection between either A-B or B-C or C-B. The bandwidth available will not remain constant throughout the cycle so you may need to run some long term viability tests. Adjust if you install more than one diaser instance on a single disk or machine. I.e. 12500 KBytes/sec or 100 Mbits/sec.',
'white')"; onmouseout="hideddrivetip()">

Lowest Max Bandwidth KBytes/s <input type="text" name="low_max_bw" size="8" maxlength="10" value="$low_max_bw_cf"/><br>
</p>

<table><tr>
<td>

<p class="color01_medium">

<img src="images/info.jpg" 
onmouseover="ddrivetip('time zone offset - the time zone UTC +/- integer value for node A, B and C, i.e. BST = UTC+1, so use 0. Daylight saving is adjusted automatically. This variable depends on the node time zone location.',
'white')"; onmouseout="hideddrivetip()">

Time zone offset node A<br>
<select name="tzone_a">
ENDHTML
	
$hours_ops = -13; # hours of operation
$selected = ""; # use text selected if value is true
$hour = -13;
while ($hours_ops <= 11) {
	$hours_ops++; # increment through the years
	$hour++;        
	
	# check for selected year from configuration file
	if ( $hour == $tzone_a_cf ) {
		$selected = "selected";
	} else { 
		$selected = ""; 
	}  
 
print <<ENDHTML;
	<option value="$hour" $selected> $hour
ENDHTML
}

print <<ENDHTML;
</select>
</p>

</td>

<td>

<p class="color01_medium">

node B<br>
<select name="tzone_b">
ENDHTML
	
$hours_ops = -13; # hours of operation
$selected = ""; # use text selected if value is true
$hour = -13;
while ($hours_ops <= 11) {
	$hours_ops++; # increment through the years
	$hour++;        
	
	# check for selected year from configuration file
	if ( $hour == $tzone_b_cf ) {
		$selected = "selected";
	} else { 
		$selected = ""; 
	}  
 
print <<ENDHTML;
	<option value="$hour" $selected> $hour
ENDHTML
}

print <<ENDHTML;
</select>
</p>

</td>

<td>

<p class="color01_medium">

node C<br>
<select name="tzone_c">
ENDHTML
	
$hours_ops = -13; # hours of operation
$selected = ""; # use text selected if value is true
$hour = -13;
while ($hours_ops <= 11) {
	$hours_ops++; # increment through the years
	$hour++;        
	
	# check for selected year from configuration file
	if ( $hour == $tzone_c_cf ) {
		$selected = "selected";
	} else { 
		$selected = ""; 
	}  
 
print <<ENDHTML;
	<option value="$hour" $selected> $hour
ENDHTML
}

print <<ENDHTML;
</select>
</p>
</td></tr></table>

<p class="color01_medium">

<img src="images/info.jpg" 
onmouseover="ddrivetip('Timeout setting for rsync cron jobs, ensures all jobs stop after 10900 hours of trying (secs) default 3 hours.',
'white')"; onmouseout="hideddrivetip()">

Timeout <input type="text" name="tout" size="8" maxlength="14" value="$tout_cf"/><br>
</p>

<hr>
Set node account variables 

<p class="color01_medium">

<img src="images/info.jpg" 
onmouseover="ddrivetip('DIASER working account. Change this if you install more than one diaser instance per disk.',
'white')"; onmouseout="hideddrivetip()">

User account <input type="text" name="user_acc" size="8" maxlength="14" value="$user_acc_cf"/><br>
</p>

<p class="color01_medium">

<img src="images/info.jpg" 
onmouseover="ddrivetip('root directory of diaser account, you may need to adjust if a large partition is not in the usual home directory place i.e. /mnt/big/ will evaluate as /mnt/big/diaser. Remeber to use the trailing /',
'white')"; onmouseout="hideddrivetip()">
<br>

Root directory A <input type="text" name="dir_a" size="10" maxlength="20" value="$dir_a_cf"/><br>
Root directory B <input type="text" name="dir_b" size="10" maxlength="20" value="$dir_b_cf"/><br>
Root directory C <input type="text" name="dir_c" size="10" maxlength="20" value="$dir_c_cf"/><br>
</p>

<p class="color01_medium">

<img src="images/info.jpg" 
onmouseover="ddrivetip('Are the nodes ubuntu or forced sudo or not?',
'white')"; onmouseout="hideddrivetip()">

Use sudo?
<select name="use_sudo">
	<option value="1" > yes
	<option value="0" selected> no
</select>
</p>

<p class="color01_medium">

<img src="images/info.jpg" 
onmouseover="ddrivetip('The sudo enabled account used to login to an Ubuntu or forced sudo OpenSSH account.',
'white')"; onmouseout="hideddrivetip()">
<br>

Sudo account A <input type="text" name="sudo_acc_name_a" size="10" maxlength="18" value="$sudo_account_name_a_cf"/><br>
Sudo account B <input type="text" name="sudo_acc_name_b" size="10" maxlength="18" value="$sudo_account_name_b_cf"/><br>
Sudo account C <input type="text" name="sudo_acc_name_c" size="10" maxlength="18" value="$sudo_account_name_c_cf"/><br>
</p>

<hr>These these variables allow you to setup and control the action of the system fill mechanism

<p class="color01_medium">

<img src="images/info.jpg" 
onmouseover="ddrivetip('Time to initiate the daily filling script this should be set in advance of the DIASER archive transfer phases to ensure DIASER is filled before the phases begin.',
'white')"; onmouseout="hideddrivetip()">

Fill start time
<select name="fill_start_time">
ENDHTML

$hours_ops = 0; # years of operation
$selected = ""; # use text selected if value is true
$hour = -1;
while ($hours_ops <= 23) {
	$hours_ops++; # decrement through the years
	$hour++;        
	
	# check for selected year from configuration file
	if ( $hour == $fill_start_time_cf ) {
		$selected = "selected";
	} else { 
		$selected = ""; 
	}  
 
print <<ENDHTML;
	<option value="$hour" $selected> 00:$hour
ENDHTML

}	

print <<ENDHTML;
</select>
</p>

<p class="color01_medium">

<img src="images/info.jpg" 
onmouseover="ddrivetip('Location of volume storage directory is where you store backup volumes created by your backup software. Remember to use trailing /.',
'white')"; onmouseout="hideddrivetip()">

Volume directory <input type="text" name="vol_dir" size="10" maxlength="20" value="$volume_dir_cf"/><br>
</p>

<p class="color01_medium">

<img src="images/info.jpg" 
onmouseover="ddrivetip('Differential or constant volume name prefix.',
'white')"; onmouseout="hideddrivetip()">

Differential or constant volume prefix<input type="text" name="diff_const_prefix" size="10" maxlength="20" value="$diff_const_prefix_cf"/><br>
</p>

<table><tr><td>

<p class="color01_medium">

<img src="images/info.jpg" 
onmouseover="ddrivetip('Choose whether full volumes are collected or not you want to simply collect constant sized volumes, like CCTV footage.',
'white')"; onmouseout="hideddrivetip()">

Collect full? 
<select name="collect_full">
	<option value="1" selected> yes
	<option value="0" > no
</select>
</p>

</td><td>

<p class="color01_medium">

<img src="images/info.jpg" 
onmouseover="ddrivetip('Day of month when full volumes are collected.',
'white')"; onmouseout="hideddrivetip()">

Collect full day of month
<select name="collect_full_day">
ENDHTML

my $days_ops = 0; # years of operation
$selected = ""; # use text selected if value is true
my $day = -1;
while ($days_ops <= 31) {
	$days_ops++; # decrement through the years
	$day++;        
	
	# check for selected year from configuration file
	if ( $day == $collect_full_day_cf ) {
		$selected = "selected";
	} else { 
		$selected = ""; 
	}  
 
print <<ENDHTML;
	<option value="$day" $selected> $day
ENDHTML

}	

print <<ENDHTML;
</select>
</p>

</td></tr></table>

<p class="color01_medium">

<img src="images/info.jpg" 
onmouseover="ddrivetip('Full volume name prefix.',
'white')"; onmouseout="hideddrivetip()">

Full volume name prefix<input type="text" name="full_prefix" size="10" maxlength="20" value="$full_prefix_cf"/><br>
</p>

<p class="color01_medium">
    <input type="submit" value="Save"> NB: for now input validation handled by core diaser, if you make a mistake the setting won't be saved and an internal error will be reported - try again.
</p>
</form>
ENDHTML

my( $name, $value );

foreach $name ( $q->param ) {
    print "$name:\n";
    foreach $value ( $q->param( $name ) ) {
        print "  $value\n";
    }
}
